/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateOrgRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateOrgRequest{}

// CreateOrgRequest struct for CreateOrgRequest
type CreateOrgRequest struct {
	// The short name of the organization
	ShortName string `json:"short_name"`
	// The name of the organization
	Name string `json:"name"`
	Authority *ListOrgsResponseOrganizationsInnerAuthority `json:"authority,omitempty"`
	Policies *CreateOrgRequestPolicies `json:"policies,omitempty"`
}

// NewCreateOrgRequest instantiates a new CreateOrgRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateOrgRequest(shortName string, name string) *CreateOrgRequest {
	this := CreateOrgRequest{}
	this.ShortName = shortName
	this.Name = name
	return &this
}

// NewCreateOrgRequestWithDefaults instantiates a new CreateOrgRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateOrgRequestWithDefaults() *CreateOrgRequest {
	this := CreateOrgRequest{}
	return &this
}

// GetShortName returns the ShortName field value
func (o *CreateOrgRequest) GetShortName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ShortName
}

// GetShortNameOk returns a tuple with the ShortName field value
// and a boolean to check if the value has been set.
func (o *CreateOrgRequest) GetShortNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ShortName, true
}

// SetShortName sets field value
func (o *CreateOrgRequest) SetShortName(v string) {
	o.ShortName = v
}

// GetName returns the Name field value
func (o *CreateOrgRequest) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *CreateOrgRequest) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *CreateOrgRequest) SetName(v string) {
	o.Name = v
}

// GetAuthority returns the Authority field value if set, zero value otherwise.
func (o *CreateOrgRequest) GetAuthority() ListOrgsResponseOrganizationsInnerAuthority {
	if o == nil || IsNil(o.Authority) {
		var ret ListOrgsResponseOrganizationsInnerAuthority
		return ret
	}
	return *o.Authority
}

// GetAuthorityOk returns a tuple with the Authority field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateOrgRequest) GetAuthorityOk() (*ListOrgsResponseOrganizationsInnerAuthority, bool) {
	if o == nil || IsNil(o.Authority) {
		return nil, false
	}
	return o.Authority, true
}

// HasAuthority returns a boolean if a field has been set.
func (o *CreateOrgRequest) HasAuthority() bool {
	if o != nil && !IsNil(o.Authority) {
		return true
	}

	return false
}

// SetAuthority gets a reference to the given ListOrgsResponseOrganizationsInnerAuthority and assigns it to the Authority field.
func (o *CreateOrgRequest) SetAuthority(v ListOrgsResponseOrganizationsInnerAuthority) {
	o.Authority = &v
}

// GetPolicies returns the Policies field value if set, zero value otherwise.
func (o *CreateOrgRequest) GetPolicies() CreateOrgRequestPolicies {
	if o == nil || IsNil(o.Policies) {
		var ret CreateOrgRequestPolicies
		return ret
	}
	return *o.Policies
}

// GetPoliciesOk returns a tuple with the Policies field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateOrgRequest) GetPoliciesOk() (*CreateOrgRequestPolicies, bool) {
	if o == nil || IsNil(o.Policies) {
		return nil, false
	}
	return o.Policies, true
}

// HasPolicies returns a boolean if a field has been set.
func (o *CreateOrgRequest) HasPolicies() bool {
	if o != nil && !IsNil(o.Policies) {
		return true
	}

	return false
}

// SetPolicies gets a reference to the given CreateOrgRequestPolicies and assigns it to the Policies field.
func (o *CreateOrgRequest) SetPolicies(v CreateOrgRequestPolicies) {
	o.Policies = &v
}

func (o CreateOrgRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateOrgRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["short_name"] = o.ShortName
	toSerialize["name"] = o.Name
	if !IsNil(o.Authority) {
		toSerialize["authority"] = o.Authority
	}
	if !IsNil(o.Policies) {
		toSerialize["policies"] = o.Policies
	}
	return toSerialize, nil
}

type NullableCreateOrgRequest struct {
	value *CreateOrgRequest
	isSet bool
}

func (v NullableCreateOrgRequest) Get() *CreateOrgRequest {
	return v.value
}

func (v *NullableCreateOrgRequest) Set(val *CreateOrgRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateOrgRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateOrgRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateOrgRequest(val *CreateOrgRequest) *NullableCreateOrgRequest {
	return &NullableCreateOrgRequest{value: val, isSet: true}
}

func (v NullableCreateOrgRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateOrgRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


